// Copyright 1995 SF Bellenot
// All Rights Reserved
// --yes it is overkill: bellenot@math.fsu.edu

// rl.h stuff needed for the bench marks
//
// bellenot may 95


#if !defined( Real )
typedef float Real;
#endif

#if !defined(TRUE)
const int TRUE = 1;
const int FALSE = 0;
#endif

typedef struct
{
        Real x, z;
} Vector;

const int MAX_COLS = 32;
const int MAX_ROWS = 13;

typedef Vector x32_LogSurf[MAX_COLS];

#define WIDE_LEFT  33
#define WIDE_RIGHT 34
#define NOT_WIDE   38
void BananaSlice ( Real, Real Top[], Real Bot[], int Status[] );
void BananaSlice ( x32_LogSurf *, Real, Real Top[], Real Bot[], int Status[] );
int BuildLogSurface( x32_LogSurf * Data, Real SmallDiam, Real LargeDiam,
	int MaxRow );

// used in both skew and slice code.
inline Real ZPointOnLineX ( Real target_x, Vector line1, Vector line2 )
{
	Real x1 = line1.x; Real x2 = line2.x;
	Real lambda = x2 - x1;

	#ifdef PARANOID
	if ( lambda == 0.0 )
	{
		cerr << "ZPointOnLineX about to divide by zero" << endl;
		stop_here();
	}
	#endif

	Real alpha = (target_x - x1) / lambda;
	Real beta = 1.0 - alpha;

	Real temp = beta * line1.z + alpha * line2.z;
	return temp; 
}
