// Copyright 1995 SF Bellenot
// All Rights Reserved
// --yes it is overkill: bellenot@math.fsu.edu
#include "bench.h"
#include "strstream.h"
int LogMaxI;

int main ( int argc, char *argv[] )
{
	int i, j, k, len, repeat = 1;
	Real sd, ld;
	Real x;
	x32_LogSurf * log = new x32_LogSurf[MAX_ROWS];

	Real Top[MAX_ROWS];
	Real Bot[MAX_ROWS];
	int Status[MAX_ROWS];

	if ( argc > 1 )
	{
		istrstream buff(argv[1]);
		buff >> repeat;
		if ( repeat <= 0 )
			return ( 1 ); 
	}

	for ( ; repeat; repeat-- )
		// 50 * 10 * 5 * 400 = 1000000 slices
		for ( sd = 7.0, j = 0; j < 50; j++, sd += 0.1 ) // 50
			for ( ld = sd, i = 0; i < 10; i++, ld += 0.2 ) // 10
				for ( len = 6; len <= 10; len++ ) // 5
				{
					BuildLogSurface ( log, sd, ld, len );
					LogMaxI = len;
					for ( x = -ld, k = 0; k < 400; k++, x += ld/200.0 ) // 400
						BananaSlice ( log, x, Top, Bot, Status );
				}
	return 0;
}
