/*
 * Copyright 1995 SF Bellenot
 * All Rights Reserved
 * --yes it is overkill: bellenot@math.fsu.edu
 */

#include <math.h>

typedef struct
{
	float fX, fY;
} POINT_F;

void InitBuild32( void );
void BuildRefArray ();
void LoadInArray ( float Radius, float wildf, int wild0, int wild1,
	int bad0, int bad1 );
int Build32( POINT_F InArray[], int ArrayCount, int harmonic, int retrys );
	/*int harmonic = 2, int retrys = 2 );*/

POINT_F InArray[120];

int main ( int argc, char *argv[] )
{
	int i, j, k, bad0, bad1, wild0, wild1, repeat = 1;
	int Number;
	float Radius, wildf;

	POINT_F GoodInArray[120];

	InitBuild32();
	BuildRefArray ();

	if ( argc > 1 )
	{
		sscanf(argv[1], "%d", &repeat);
		if ( repeat <= 0 )
			return ( 1 ); 
	}

	for ( ; repeat; repeat-- )
		/* 2 * 5 * 2 * 5 * 2 * 5 = 1000 b32's */
		for ( bad0 = 0; bad0 < 20; bad0 += 10 ) /* 2 */
		for ( i = 0; i < 20; i += 4 ) /* 5*/
			for ( wildf = 0.9; wildf < 1.2; wildf += 0.2 ) /* 2 */
			for ( wild0 = 60; wild0 < 110; wild0 += 10 ) /* 5 */
			for ( j = 0; j < 20; j += 10 ) /* 2 */
				for ( Radius = 5.0, k = 0; k < 5; k++, Radius += 1.0 ) /* 5 */
				{
					bad1 = bad0 + i;
					wild1 = wild0 + j;
					LoadInArray ( Radius, wildf, wild0, wild1, bad0, bad1 );
					Number = LoadPoints ( GoodInArray, InArray );
					Build32( InArray, Number, 2, 2 );
				}
	return 0;
}

POINT_F RefArray[120];

void LoadInArray ( float Radius, float wildf, int wild0, int wild1,
	int bad0, int bad1 )
{
	int i, j;

	for ( i = 0; i < 120; i++ )
	{
		InArray[i].fX = Radius * RefArray[i].fX;
		InArray[i].fY = Radius * RefArray[i].fY;
		#if 0
		printf ( "%f %f\n", InArray[i].fX, InArray[i].fY );
		#endif
	}

	/* bad data */
	for ( i = bad0; i <= bad1; i++ )
		InArray[i].fY = -2.0;

	/* wild data */
	for ( i = wild0; i <= wild1; i++ )
	{
		InArray[i].fX *= wildf;
		InArray[i].fY *= wildf;
	}
}

#define DEG15 (M_PI/12.0)
#define DEG6 (M_PI/30.0)
#define DEG1 (M_PI/180)

float Start[] =
{
	- 4 * DEG15, - 4 * DEG15 + DEG1,
	- DEG15, 5 * DEG15,
	8 * DEG15, 8 * DEG15 + DEG1
};

float Fuzz[] =
{
	1.03, 0.98, 0.99, 1.01, 0.97, 1.02
};

void BuildRefArray ()
{
	int i, j;

	for ( j = 0; j < 6; j++ )
		for ( i = 0; i < 20; i++ )
		{
			RefArray[j*20+i].fX = Fuzz[j] * cos(Start[j] + i * DEG6);
			RefArray[j*20+i].fY = Fuzz[j] * sin(Start[j] + i * DEG6) + 1.0;
		}
}
