// Copyright 1995 SF Bellenot
// All Rights Reserved
// --yes it is overkill: bellenot@math.fsu.edu
// skew.h
class Skew
{
protected:
	x32_LogSurf *log;
	int bot_row;
	int top_row;
	int bot_left;
	int top_right;
	Vector bot_position;
	Vector top_position;
//	Real length;
	Real offset; // bot_position.x is top_position.x + offset

// more private-methods except for testing
	void print();
	Real top_alt();
	Real bot_alt();
	int top_intersection ( Real intersection_x );
	int bot_intersection ( Real intersection_x );
	int trap_length ( Real new_length );
	int guide_shift ( Real new_length, Real GuideBarV );
	int shift_calc1 ( Real new_length );
	int shift_calc2 ( Real new_length );
// testing functions
	friend void skew_limit_check ( Real, Real, Real, Real );
	friend void skew_guide_check ( Real, Real, Real );
	friend void skew_check ( Real, Real );
	friend void old_skew_test ( void );
	friend void moving_guide_test ( Real, Real, Real );
public:
	Skew ( x32_LogSurf * ls, int bot_row, int top_row, Real offset );
	inline Real Tx () { return top_position.x; };
	inline Real Bx () { return bot_position.x; };
	inline Real Tz () { return top_position.z; };
	inline Real Bz () { return bot_position.z; };
	inline Real Length () { return top_position.z - bot_position.z; }
	inline Vector Top () { return top_position; };
	inline Vector Bot () { return bot_position; };
	int intersection ( Real intersection_x );
	int shift_calc ( Real new_length );
	int limit_shift_calc ( Real new_length, Real Topz, Real Botz );
	int moving_guide_shift ( Real new_length, Real d2_cant,
		int RGuideBarRow, int LGuideBarRow );
};
