// Copyright 1995 SF Bellenot
// All Rights Reserved
// --yes it is overkill: bellenot@math.fsu.edu
// XGivenTwoLen and old v.h stuff
#ifndef _SKEWHELP_H_
#define _SKEWHELP_H_

inline Vector v_add (Vector p, Vector q)
{
        Vector sum;

        sum.x = p.x + q.x;
        sum.z = p.z + q.z;

        return sum;
}

inline Vector scalar_mult (Real alpha, Vector v)
{
        Vector w;

        w.x = alpha * v.x;
        w.z = alpha * v.z;

        return w;
}

inline Real XGivenTwoLen ( Real length, Real len1, Real len2, Real x1, Real x2 )
{
	Real lambda = len2 - len1;

	Real alpha = (length - len1)/lambda;
	Real beta = 1.0 - alpha;

	return alpha * x2 + beta * x1;
}

#endif
