// Copyright 1995 SF Bellenot
// All Rights Reserved
// --yes it is overkill: bellenot@math.fsu.edu
#include "bench.h"
#include "strstream.h"
#include "skew.h"
int LogMaxI;

int main ( int argc, char *argv[] )
{
	int i, j, k, len, repeat = 1;
	int top, bot;
	Real off;
	Real sd, ld;
	Real x;
	x32_LogSurf * log = new x32_LogSurf[MAX_ROWS];

	if ( argc > 1 )
	{
		istrstream buff(argv[1]);
		buff >> repeat;
		if ( repeat <= 0 )
			return ( 1 ); 
	}

	for ( ; repeat; repeat-- )
		// 50 * 10 * 5 * 5 * 5 * 2 * 8 = 1000000 shift_calc's
		for ( sd = 7.0, j = 0; j < 50; j++, sd += 0.1 ) // 50
			for ( ld = sd, i = 0; i < 10; i++, ld += 0.2 ) // 10
				for ( len = 6; len <= 10; len++ ) // 5
				{
					BuildLogSurface ( log, sd, ld, len );
					LogMaxI = len;
					for ( top = 0; top < 5; top++ ) // 5
						for ( bot = 1; bot < 6; bot++ ) // 5
							for ( off = 0.0; off < 1.0; off += 0.5 ) // 2
							{
								Skew sk( log, bot, top, off );
								// 8
								for ( x = 0.1, k = 0; k < 8; k++, x += ld/20.0)
									sk.shift_calc ( x );
							}
				}
	return 0;
}
